// randomizer.cpp

#include "randomizer.h"

RandLib rl;

// algorithms

int BBS_GetIntegerA()
{
   return rl.BBS_GetInteger();
}

float BBS_GetFloatA()
{
   return (float) rl.BBS_GetDouble();
}

int MOA_GetIntegerA()
{
   return rl.MOA_GetInteger();
}

float MOA_GetFloatA()
{
   return (float) rl.MOA_GetDouble();
}

int MTW_GetIntegerA()
{
   return rl.MTW_GetInteger();
}

float MTW_GetFloatA()
{
   return (float) rl.MTW_GetDouble();
}

int RNC_GetIntegerA()
{
   return rl.RNC_GetInteger();
}

float RNC_GetFloatA()
{
   return (float) rl.RNC_GetDouble();
}

int RSH_GetIntegerA()
{
   return rl.RSH_GetInteger();
}

float RSH_GetFloatA()
{
   return (float) rl.RSH_GetDouble();
}

int RRW_GetIntegerA()
{
   return rl.RRW_GetInteger();
}

float RRW_GetFloatA()
{
   return (float) rl.RRW_GetDouble();
}

int TPR_GetIntegerA()
{
   return rl.TPR_GetInteger();
}

float TPR_GetFloatA()
{
   return (float) rl.TPR_GetDouble();
}

// initialization

void SetSeedA(char * the_seed)
{
   unsigned long seed;

   seed = atol(the_seed);
   rl.SetSeed(seed);
}

void SetIntegerRangeA(int the_min, int the_max)
{
   rl.SetIntegerRange(the_min,the_max);
}

void BBS_InitA(char * p, char * q, char * key)
{
   verylong the_p = 0;
   verylong the_q = 0;
   verylong the_key = 0;

   zsread(p,&the_p);
   zsread(q,&the_q);
   zsread(key,&the_key);
   rl.BBS_Init(the_p,the_q,the_key);
   zfree(&the_p);
   zfree(&the_q);
   zfree(&the_key);
}

void BBS_BlumInitA(char * seed)
{
   verylong the_seed = 0;

   zsread(seed,&the_seed);
   rl.BBS_BlumInit(the_seed);
   zfree(&the_seed);
}

void BBS_GenBlumPrimeA(char * p, int numbits)
{
   verylong the_p = 0;

   the_p = rl.BBS_GenBlumPrime(numbits);
   zswrite(p,the_p);
   zfree(&the_p);
}

void BBS_GenKeyA(char * p, char * q, char * key)
{
   verylong the_p = 0;
   verylong the_q = 0;
   verylong the_key = 0;

   zsread(p,&the_p);
   zsread(q,&the_q);
   the_key = rl.BBS_GenKey(the_p,the_q);
   zswrite(key,the_key);
   zfree(&the_p);
   zfree(&the_q);
   zfree(&the_key);
}

